function [ dekod3, cesta3, hodnoty_cest ] = dekoder_viterbi( prij_zprava )

% dekodovani
tab_s_kod = [4 0 0 1; 
             3 1 1 3;  
             2 1 0 5; 
             1 0 1 7; 
             4 1 1 1; 
             3 0 0 3; 
             2 0 1 5; 
             1 1 0 7];
%prvni krok dekodovani, testovani jen dvou stavu, protoze se vychazi z uzlu
%00
dekod1 = [];
cesta1 = [0 4;0 4];
hodnoty_cest = [];
hammingovy_vzdalenosti = [];
for i = 1:2 % z uzlu 00 dojde pouze k jednomu rozdvojeni, proto i=1:2
    p = 0;  %pomocna promenna pro pocitani hammingovy vzdalenosti
    for j = 1:2
        if prij_zprava(1,j) ~= tab_s_kod(i, j+1) %testuje se, zda je dana
%cesta spravna, pokud ne, tak se zvysi hammingova vzdalenost dane cesty
            p = p + 1;
        end
        dekod1(i, j+2) = tab_s_kod(i, j + 1);
    end   
    dekod1(i,1) = p; % hamingova vzdlenost od vyslane zpravy
    dekod1(i,2) = tab_s_kod(i,end); % druhy znak radku matice znaci,
                                    %z jakeho uzlu se ma pokracovat
    cesta1(i,1) = p;
    cesta1(i,3) = tab_s_kod(i,1);
    
    hammingovy_vzdalenosti(i,1) = p;
end
cesta2 = [cesta1(1,:); cesta1(1,:); cesta1(2,:); cesta1(2,:)];
dekod2 = [dekod1(1,:); dekod1(1,:); dekod1(2,:); dekod1(2,:)];
hammingovy_vzdalenosti2 = [hammingovy_vzdalenosti(1,:); hammingovy_vzdalenosti(1,:); hammingovy_vzdalenosti(2,:); hammingovy_vzdalenosti(2,:)];
%dva radky pod sebou stejne, aby se mohly uzly 00 a 10 zase kazdy rozdvojit
%a pocitat nova hammingova vzdalenos
for i = 1:4 %zde dojde k rozdvojeni ze dvou uzlu, proto i=1:4                                                                                                                                                                                                                                                                                             
    p = 0;
    for j = 1:2
        if prij_zprava(2,j) ~= tab_s_kod(i, j+1)
            p = p + 1;
        end
        dekod2(i, j+4) = tab_s_kod(i, j + 1);
    end
    dekod2(i,1) = dekod2(i,1) + p; 
    dekod2(i,2) = tab_s_kod(i,end); 
    cesta2(i,1) = cesta2(i,1) + p;
    cesta2(i,4) = tab_s_kod(i,1);
    
    hammingovy_vzdalenosti2(i,2) = hammingovy_vzdalenosti2(i,1) + p;
end

dekod3 = [dekod2(1,:); dekod2(1,:); dekod2(2,:); dekod2(2,:);
          dekod2(3,:); dekod2(3,:); dekod2(4,:); dekod2(4,:)];
cesta3 = [cesta2(1,:); cesta2(1,:); cesta2(2,:); cesta2(2,:);
          cesta2(3,:); cesta2(3,:); cesta2(4,:); cesta2(4,:)];
hodnoty_cest = [hammingovy_vzdalenosti2(1,:); hammingovy_vzdalenosti2(1,:); hammingovy_vzdalenosti2(2,:); hammingovy_vzdalenosti2(2,:);
          hammingovy_vzdalenosti2(3,:); hammingovy_vzdalenosti2(3,:); hammingovy_vzdalenosti2(4,:); hammingovy_vzdalenosti2(4,:)];
k = 6; % poradi na ktere misto se ma v matici dekod3 zapisovat do sloupce
       % 6 sest proto, ze prvni misto je celkova hammingova vzdalenost a
       % druhe je uzel, kterym se ma pokravoat
       % vzdalenost a dalsi 4 dekodovana zprava z predchozich kroku
       
sl = 5;
for ntice_prij_zpravy = 3:size(prij_zprava, 1) % opakovani viterbiho 
                                               % mrizkoveho algoritmu
   krok = 4;
   krok1 = 4;
    for i = 1:2:7 % zde se testuje na pokracovani z uzlu nulou,                                                                                                                                                                                                                                                                                                                              
        p = 0;    %cili liche radky tabulky
        for j = 1:2
            if prij_zprava(ntice_prij_zpravy,j) ~= tab_s_kod(i, j+1)
            %testuje se od treti dvojice prijate zpravy, jelikoz prvni dve
            %byly zkontrolovany samostatne
                p = p + 1;
            end
            dekod3(i, k + j) = tab_s_kod(i, j + 1);         
        end
        dekod3(i,1) = dekod3(i,1) + p;
        dekod3(i,2) = tab_s_kod(i,end);
        
        cesta3(i,1) = cesta3(i,1) + p;
        cesta3(i,sl) = tab_s_kod(i,1);
                                      
    end
    
    for i = 2:2:8 % zde se testuje na pokracovani z uzlu jednickou,                                                                                                                                                                                                                                                                                                                              
        p = 0;    %cili sude radky tabulky                                                                                                                                                                                                                                                                                             
        for j = 1:2
            if prij_zprava(ntice_prij_zpravy,j) ~= tab_s_kod(i, j+1)
                p = p + 1;
            end
            dekod3(i, k+j) = tab_s_kod(i, j + 1);           
        end
        dekod3(i,1) = dekod3(i,1) + p; 
        dekod3(i,2) = tab_s_kod(i,end);
        
        cesta3(i,1) = cesta3(i,1) + p;
        cesta3(i,sl) = tab_s_kod(i,1);
    end
    k = k + 2; %znaci, do jakeho sloupce se ma
               %zapisovat dekodovane znaky zpravy
    sl = sl + 1;
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % serazeni radku matice dekod3
    dekod_serazeni = dekod3;
    hodnoty_cest(:,ntice_prij_zpravy) = dekod3(:,1);
    %prvni dva radky 1 a 2
    [ dekod3 ] = preskladani_matice( dekod3, dekod_serazeni, 1 );
    % radek 3 a 4
    [ dekod3 ] = preskladani_matice( dekod3, dekod_serazeni, 3 );
    % radek 5 a 6
    [ dekod3 ] = preskladani_matice( dekod3, dekod_serazeni, 5 );
    % radek 7 a 8
    [ dekod3 ] = preskladani_matice( dekod3, dekod_serazeni, 7 );
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % serazeni radku matice cesta3
    cesta_serazeni = cesta3;
    %prvni dva radky 1 a 2
    [ cesta3 ] = preskladani_matice_pro_cestu( cesta3, cesta_serazeni, 1, 4 );
    % radek 3 a 4
    [ cesta3 ] = preskladani_matice_pro_cestu( cesta3, cesta_serazeni, 3, 3 );
    % radek 5 a 6
    [ cesta3 ] = preskladani_matice_pro_cestu( cesta3, cesta_serazeni, 5, 2 );
    % radek 7 a 8
    [ cesta3 ] = preskladani_matice_pro_cestu( cesta3, cesta_serazeni, 7, 1 );
    
    
end

end

