function [ kod_zpr, kod_zpr_radky, mrizka ] = koder_viterbi( m )

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%koder
%tabulka stavu koderu pro (R = 1/2) a generujici polynom
% x^5 + x^4 + x^3 + 0 + x + 1
% stav koderu v case ti- prvni sloupec tabulky
%druhy a treti sloupec jsou dohromady vystup v case ti
%ctvrty sloupec ukazuje na radek, kterym se ma v dalsim kroku pokracovat
tab_s_kod = [4 0 0 1; %0 | 4   %nuly jsou liche, jednicky sude radky
             3 1 1 3; %1 | 3
             2 1 0 5; %0 | 2
             1 0 1 7; %1 | 1
             4 1 1 1; %0 | 4
             3 0 0 3; %1 | 3
             2 0 1 5; %0 | 2
             1 1 0 7];%1 | 1
p = 1; % pomocna promenna pro urceni radku matice
kod_zpr = []; % zakodovana informace
kod_zpr_radky = [];
mrizka = [4];%postup v trellis mrizce
% pokud se koduje jednicka plati sudy radek tzn. p+1
% pokud se koduje nula plati lichy radek tzn. p
% na konci kodovani se do p ulozi hodnota radku, na kterem se ma v dalsim
% kroku zacit a podle hodnoty m(i) se urci konecny radek
for i = 1:size(m,2)
    if m(i) == 1
       kod_zpr = [kod_zpr; tab_s_kod(p+1, 2:3)];
       kod_zpr_radky = [kod_zpr_radky tab_s_kod(p+1, 2:3)];
       mrizka = [mrizka, tab_s_kod(p+1, 1)];
       p = tab_s_kod(p+1, end);
       
    else
       kod_zpr = [kod_zpr; tab_s_kod(p, 2:3)];
       kod_zpr_radky = [kod_zpr_radky tab_s_kod(p, 2:3)];
       mrizka = [mrizka, tab_s_kod(p, 1)];
       p = tab_s_kod(p, end);
       
    end
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


end

