function [ G, H ] = EG_LDPC( s )

% Vytvoen matice pole konench prvk
elementy=gftuple([-1:2^(2*s)-2]',2*s,2);
% Volba parametru beta
beta=(2^(2*s)-1)/(2^s-1);

ni = [0,1]; %koeficienty alfa pro dosazeni do vzorce pro nalezeni 1 ve v
for i = 1:(2^s)-2
    ni = [ni,beta*i];
end
%prvky alfa obsahuji misto ve vektoru v, na kterych maji byt jednicky
for i = 1:(2^s)
   if i == 1
       alfa(i) = size(elementy,1)-2;
   elseif i == 2
       for j = 1:size(elementy,1)
           if elementy(j,:) == xor(elementy(end,:),elementy(3,:))
               alfa(i) = j-2;
           end
       end
   else
       for j = 1:size(elementy,1)
           if elementy(j,:) == xor(elementy(end,:),elementy(ni(i)+3,:))
               alfa(i) = j-2;
           end
       end
   end
end
%vektor v pro generovani matice H
for i = 1:size(alfa,2)
   v(alfa(i)+1) = 1;
end
%vytvoreni matice H
H=[v];
for i = 1:size(v,2)-1
   H = [H; (circshift(v',i))'];  
end
%vytvoreni matice G

% Nalezen nulovch bod
nulove_b= [];
for h=1:2^(2*s)-2  
    max(h) = -inf;
    for l=0:s-1
        hl = mod(h*(2^l),2^(2*s)-1);
        delta = [mod(hl,2^s) floor(hl/2^s)];
        if sum(delta(:)) > max(h)
            max(h) = sum(delta(:));
        end
    end
    if ((max(h) > 0) && (max(h) <= 2^s-1))
        nulove_b = [nulove_b h];
    end
end

% Vytvoen generujcho vektoru g
alpha = gf(2,2*s);
g = [1 alpha^nulove_b(1)];
for i=2:length(nulove_b)
    g = conv(g,[1 alpha^nulove_b(i)]);
end
gbin = double(g.x);

%vektor gEG je generujici vektor
gEG1 = rot90(rot90(gbin));
k = 2^(2*s) - 3^s;
n = 2^(2*s) - 1;
gEG = zeros(1,n);
for i = 1:size(gEG1,2)
    if gEG1(i) == 1
        gEG(i) = 1;
    end
end
%vytvoreni matice G pomoci rotace
G=[gEG];
for i = 1:k-1
   G = [G; (circshift(gEG',i))'];  
end

% Pevod na systematick tvar G=[I P]
for i=size(G):-1:2
    for j=size(G):-1:1
        if G(j,i)==1 && i~=j
            G(j,:)=xor(G(j,:),G(i,:));
        end
    end
end

end

