function [ opr_zpr, p, Q0j_vypis, Q1j_vypis ] = oprava_LDPC_SP( prenesena_posl, vysl_nas_mat, H, pocet_iter )
p = 1;

%modulace
for i = 1:size(prenesena_posl, 2)
   if prenesena_posl(i) == 1
       modulace(i) = 1;
   else
       modulace(i) = -1;
   end
end
%awgn
modulace = awgn(modulace, 15);

%dvojice pravdep
    rozptyl = 0.8;
    for i = 1:size(modulace,2)
       f1(i) = 1/(1+exp(-2*modulace(i)/rozptyl^2));
       f0(i) = 1 - f1(i);
    end
    
Q0j_vypis = [];
Q1j_vypis = [];
while (p <= pocet_iter)
    
    
    if p == 1
        %tvrde rozhodnuti
        for i = 1:size(f0,2)
            if f0(i) > f1(i)
                tvrde_roz(i) = 0;
            else
    
                tvrde_roz(i) = 1;
            end
        end
        if sum(nasobeni_matic_XOR( tvrde_roz, H' )) == 0 & isequal(vysl_nas_mat, tvrde_roz)
            opr_zpr = tvrde_roz;
            break
        else
        end
    else
        f0 = Q0j;
        f1 = Q1j;
    end
    if p == 1
        Q0j_vypis = [Q0j_vypis; round(f0,3)];
        Q1j_vypis = [Q1j_vypis; round(f1,3)];
    end
    %matice Qij
    %Q0ij
    Q0ij = [];
    for i = 1:size(H,1)
       Q0ij = [Q0ij; H(i,:).*f0];
    end
    %Q1ij
    Q1ij = [];
    for i = 1:size(H,1)
       Q1ij = [Q1ij; H(i,:).*f1];
    end

    %rozdil Q0ij-Q1ij
    dQij = Q0ij - Q1ij;

    %matice dRij
    for i = 1:size(dQij, 1)
        k=1;
        %pom_mat = zeros( (size(dQij, 1)), (sum(dQij(1,:))));
       for j = 1:size(dQij,2)
          if  dQij(i,j) ~= 0
              pom_mat(i,k) = j;
              k=k+1;
          end
       end
    end
    dRij = zeros(size(pom_mat,1),size(pom_mat,2));
    for i = 1:size(pom_mat,1)
       for j = 1:size(pom_mat,2)
          dRij(i, pom_mat(i,j)) = 1; 
       end
    end

    for i = 1:size(dRij,1)
       for j = 1:size(pom_mat,2)
          nenasobit = dRij(i,pom_mat(i,j));
          dRij(i,:) = dRij(i,:)*dQij(i,pom_mat(i,j));
          dRij(i,pom_mat(i,j)) = nenasobit;
       end
    end

    %R0ij
    for i = 1:size(dRij,1)
       for j = 1:size(dRij,2)
          if dRij(i,j) ~= 0 
            R0ij(i,j) = 0.5*(1 + dRij(i,j));
          end
       end
    end

    %R1ij
    for i = 1:size(dRij,1)
       for j = 1:size(dRij,2)
          if dRij(i,j) ~= 0 
            R1ij(i,j) = 0.5*(1 - dRij(i,j)); 
          end
       end
    end

    %alfaij, Q0j, Q1j
    for i = 1:size(R0ij,2)
        eR0ij = 1;
        eR1ij = 1;
       for j = 1:size(R0ij,1)
           if R0ij(j,i) ~= 0
              eR0ij = eR0ij * R0ij(j,i);
              eR1ij = eR1ij * R1ij(j,i);
           end
       end
       alfaij(i) = 1/((f0(i)*eR0ij) + (f1(i)*eR1ij));
       Q0j(i) = alfaij(i) * f0(i) * eR0ij;
       Q1j(i) = alfaij(i) * f1(i) * eR1ij;
    end
    Q0j_vypis = [Q0j_vypis; round(Q0j,3)];
    Q1j_vypis = [Q1j_vypis; round(Q1j,3)];

    
    %tvrde rozhodnuti2
    for i = 1:size(Q0j,2)
        if Q0j(i) > Q1j(i)
            tvrde_roz2(i) = 0;
        else
            tvrde_roz2(i) = 1;
        end
    end
    
    if (sum(nasobeni_matic_XOR( tvrde_roz2, H' )) == 0) & isequal(vysl_nas_mat, tvrde_roz2)
        opr_zpr = tvrde_roz2;
        break
    elseif (sum(nasobeni_matic_XOR( tvrde_roz2, H' )) == 0) & (isequal(vysl_nas_mat, tvrde_roz2))==0
        opr_zpr = tvrde_roz2;
        break
    else
        opr_zpr = tvrde_roz2;
    end

    
    p = p + 1;
end
end

